diff --git a/test/unit/tui/bubble_model_test.rb b/test/unit/tui/bubble_model_test.rb
index bfc3e63b..e1e1ab66 100644
--- a/test/unit/tui/bubble_model_test.rb
+++ b/test/unit/tui/bubble_model_test.rb
@@ -345,18 +345,43 @@ class HiveTuiBubbleModelTest < Minitest::Test
     assert_includes out, "/auth"
   end
 
-  def test_view_composes_idea_preview_onto_grid_in_idea_preview_mode
+  def test_view_renders_full_screen_info_panel_in_idea_preview_mode
+    row = make_task_row(slug: "some-slug")
+    content = Hive::Tui::InfoPanelContent::Content.new(
+      slug: "some-slug",
+      stage: "2-brainstorm",
+      created_at: "2026-05-20T00:00:00Z",
+      created_at_available: true,
+      original_text: "original idea",
+      original_text_available: true,
+      original_text_truncated: false,
+      task_folder: "/tmp/hive/some-slug",
+      latest_log_path: nil,
+      latest_log_available: false,
+      stage_extra_kind: :brainstorm,
+      stage_extra_label: "brainstorm.md",
+      stage_extra_text: "Q1 answer",
+      stage_extra_available: true,
+      stage_extra_truncated: false
+    )
+    state = Hive::Tui::Model::IdeaPreviewState.new(
+      row: row, token: 1, status: :ready, content: content
+    )
     @model = Hive::Tui::BubbleModel.new(
       hive_model: Hive::Tui::Model.initial.with(
         mode: :idea_preview,
-        idea_preview_slug: "some-slug",
-        idea_preview_text: "original idea"
+        idea_preview_state: state,
+        cols: 80,
+        rows: 24
       ),
       dispatch: @dispatch
     )
     out = @model.view
-    assert_includes out, "Idea for some-slug:"
+    assert_includes out, "Info · some-slug"
     assert_includes out, "original idea"
+    assert_includes out, "brainstorm.md"
+    assert_includes out, "[q] close"
+    refute_includes out, "[Tab] switch", "info panel must replace the grid, not compose under it"
   end
 
   # Regression: paste-truncated / paste-timeout / overflow flashes
@@ -603,28 +628,35 @@ class HiveTuiBubbleModelTest < Minitest::Test
     refute_includes out, "[Enter] open",   "Enter is not only an open action"
   end
 
-  def test_default_footer_hint_omits_o_at_70_col_budget
-    # Plan R6: `[o] open` is included in the footer only if it fits
-    # the 70-col budget without wrapping or pushing primary actions
-    # onto a second line. At 70 cols the current hint string is
-    # already ~69 chars; adding ten more (separator + "[o] open")
-    # would exceed the budget. We rely on the `?` overlay for
-    # discoverability instead. This test pins that decision so a
-    # future contributor doesn't silently re-add the hint and break
-    # 70-col rendering.
+  def test_default_footer_hint_includes_i_info_between_help_and_quit
     hint = @model.send(:footer_hint)
-    assert_equal "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [q] quit",
-                 hint,
-                 "footer hint must remain the pre-`o` literal; `o` is documented in `?` only"
+    assert_equal "[Tab] switch  [Enter] action  [n] new  [/] filter  [?] help  [i] info  [q] quit",
+                 hint
+    help_idx = hint.index("[?] help")
+    info_idx = hint.index("[i] info")
+    quit_idx = hint.index("[q] quit")
+    assert help_idx < info_idx
+    assert info_idx < quit_idx
     refute_includes hint, "[o] open",
-                    "70-col budget can't absorb `[o] open` alongside primary hints"
-    # Width guard: pin the actual character count so a future contributor
-    # who adds a hint and (correctly) bumps the literal above also has to
-    # acknowledge they're spending bytes against the 70-col budget. If
-    # this assertion fires alongside an updated literal, the contributor
-    # MUST verify default_footer truncation behavior at cols == 70.
-    assert hint.length <= 70,
-           "footer hint must fit the 70-col budget without truncation; got #{hint.length} chars"
+                    "`o` stays documented in `?` only; legend keeps the primary set"
+  end
+
+  def test_default_footer_wraps_before_help_on_narrow_width
+    @model = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial.with(mode: :grid, cols: 70, rows: 24),
+      dispatch: @dispatch
+    )
+    footer = @model.send(:default_footer, 69)
+    lines = footer.lines(chomp: true)
+    assert lines.all? { |line| line.length <= 69 },
+           "each footer line must fit usable width: #{lines.inspect}"
+    joined = lines.join(" ")
+    assert_includes joined, "[?] help"
+    assert_includes joined, "[i] info"
+    assert_includes joined, "[q] quit"
+    # Prefer the help/info/quit group intact on one line.
+    assert lines.any? { |line| line.include?("[?] help") && line.include?("[i] info") && line.include?("[q] quit") },
+           "help/info/quit group must stay together: #{lines.inspect}"
   end
 
   def test_grid_mode_collapses_to_single_pane_below_min_cols
@@ -3658,19 +3690,64 @@ class HiveTuiBubbleModelTest < Minitest::Test
       "OpenTaskFolder must not dispatch any follow-up message — no auto-continue, no InputEditorExited"
   end
 
-  # ---- OpenIdeaPreview → bottom-strip preview (read-only) ----
+  # ---- OpenIdeaPreview → full-screen info panel (read-only, async load) ----
+
+  def drain_idea_preview_cmd(cmd)
+    assert_kind_of Proc, cmd, "open must return a background load command"
+    cmd.call
+    @messages.each { |msg| @model.update(msg) }
+    @messages.clear
+  end
 
-  def test_open_idea_preview_reads_original_text_and_enters_preview_mode
+  def test_open_idea_preview_enters_loading_immediately_without_waiting
     with_tmp_dir do |dir|
       write_idea_md(dir, original_text: "Build task from user note")
       row = make_task_row(folder: dir, slug: "some-slug")
 
       _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
 
-      assert_nil cmd
+      assert_kind_of Proc, cmd
       assert_equal :idea_preview, @model.hive_model.mode
-      assert_equal "Build task from user note", @model.hive_model.idea_preview_text
-      assert_equal "some-slug", @model.hive_model.idea_preview_slug
+      state = @model.hive_model.idea_preview_state
+      refute_nil state
+      assert state.loading?
+      assert_equal row.slug, state.row.slug
+      assert_nil state.content
+      assert_empty @messages, "load command must not have run yet"
+    end
+  end
+
+  def test_open_idea_preview_load_command_sets_ready_content
+    with_tmp_dir do |dir|
+      write_idea_md(dir, original_text: "Build task from user note")
+      row = make_task_row(folder: dir, slug: "some-slug", stage: "2-brainstorm")
+      File.write(File.join(dir, "brainstorm.md"), "notes\n")
+
+      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      drain_idea_preview_cmd(cmd)
+
+      state = @model.hive_model.idea_preview_state
+      assert state.ready?
+      assert_equal "some-slug", state.content.slug
+      assert_includes state.content.original_text, "Build task from user note"
+    end
+  end
+
+  def test_open_idea_preview_load_command_contains_system_stack_errors
+    with_tmp_dir do |dir|
+      row = make_task_row(folder: dir, slug: "deep-yaml")
+      loader = lambda do |_row|
+        raise SystemStackError, "nesting too deep while parsing YAML"
+      end
+
+      with_replaced_singleton_method(Hive::Tui::InfoPanelContent, :load, loader) do
+        _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+        drain_idea_preview_cmd(cmd)
+      end
+
+      state = @model.hive_model.idea_preview_state
+      assert state.error?
+      assert_match(/SystemStackError: nesting too deep/, state.error_message)
     end
   end
 
@@ -3684,91 +3761,114 @@ class HiveTuiBubbleModelTest < Minitest::Test
     assert_match(/no idea for some-slug/, @model.hive_model.flash.to_s)
   end
 
-  def test_open_idea_preview_flashes_when_idea_md_missing
+  def test_open_idea_preview_missing_idea_still_opens_loading_panel
     with_tmp_dir do |dir|
       row = make_task_row(folder: dir)
 
       _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      assert_equal :idea_preview, @model.hive_model.mode
+      assert @model.hive_model.idea_preview_state.loading?
 
-      assert_nil cmd
-      assert_equal :grid, @model.hive_model.mode
-      assert_match(/no idea\.md for some-slug/, @model.hive_model.flash.to_s)
+      drain_idea_preview_cmd(cmd)
+      state = @model.hive_model.idea_preview_state
+      assert state.ready?
+      refute state.content.original_text_available
     end
   end
 
-  def test_open_idea_preview_flashes_when_original_text_missing
+  def test_open_idea_preview_does_not_dispatch_or_mutate_marker
     with_tmp_dir do |dir|
-      File.write(File.join(dir, "idea.md"), "---\nslug: some-slug\n---\n")
+      idea_path = write_idea_md(dir, original_text: "Read only")
+      before = File.read(idea_path)
+      before_mtime = File.mtime(idea_path)
       row = make_task_row(folder: dir)
 
       _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      drain_idea_preview_cmd(cmd)
+      @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "q".ord ]))
 
-      assert_nil cmd
+      assert_empty @messages
+      assert_equal before, File.read(idea_path)
+      assert_equal before_mtime, File.mtime(idea_path)
       assert_equal :grid, @model.hive_model.mode
-      assert_match(/idea has no original_text for some-slug/, @model.hive_model.flash.to_s)
     end
   end
 
-  def test_open_idea_preview_flashes_on_unreadable_idea_md
+  def test_idea_preview_stale_load_after_close_is_ignored
     with_tmp_dir do |dir|
-      File.write(File.join(dir, "idea.md"), "---\noriginal_text: [broken\n---\n")
+      write_idea_md(dir, original_text: "Stale")
       row = make_task_row(folder: dir)
 
       _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      token = @model.hive_model.idea_preview_state.token
+      @model.update(Hive::Tui::Messages::BACK)
+      assert_equal :grid, @model.hive_model.mode
+
+      cmd.call
+      loaded = @messages.find { |m| m.is_a?(Hive::Tui::Messages::IdeaPreviewLoaded) }
+      refute_nil loaded
+      assert_equal token, loaded.token
+      @model.update(loaded)
 
-      assert_nil cmd
       assert_equal :grid, @model.hive_model.mode
-      assert_match(/could not read idea for some-slug/, @model.hive_model.flash.to_s)
+      assert_nil @model.hive_model.idea_preview_state
     end
   end
 
-  def test_open_idea_preview_does_not_dispatch_or_mutate_marker
+  def test_idea_preview_close_keys_q_esc_i
     with_tmp_dir do |dir|
-      idea_path = write_idea_md(dir, original_text: "Read only")
-      before = File.read(idea_path)
+      write_idea_md(dir, original_text: "Roundtrip idea")
       row = make_task_row(folder: dir)
 
-      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      [ "q", :escape, "i" ].each do |close_key|
+        @messages.clear
+        _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+        drain_idea_preview_cmd(cmd)
+        assert_equal :idea_preview, @model.hive_model.mode
 
-      assert_nil cmd
-      assert_empty @messages
-      assert_equal before, File.read(idea_path)
+        key_msg = if close_key == :escape
+                    Bubbletea::KeyMessage.new(key_type: Bubbletea::KeyMessage::KEY_ESC, runes: [])
+        else
+                    Bubbletea::KeyMessage.new(key_type: 0, runes: [ close_key.ord ])
+        end
+        _, dismiss_cmd = @model.update(key_msg)
+        assert_nil dismiss_cmd
+        assert_equal :grid, @model.hive_model.mode, "#{close_key.inspect} must close panel"
+        assert_nil @model.hive_model.idea_preview_state
+      end
     end
   end
 
-  def test_open_idea_preview_truncates_oversized_original_text
+  def test_idea_preview_unmapped_key_is_noop
     with_tmp_dir do |dir|
-      original = "x" * (Hive::Tui::Model::NEW_IDEA_BUFFER_MAX_CHARS + 20)
-      write_idea_md(dir, original_text: original)
+      write_idea_md(dir, original_text: "Stay open")
       row = make_task_row(folder: dir)
-
       _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      drain_idea_preview_cmd(cmd)
+      before = @model.hive_model
 
-      assert_nil cmd
+      _, dismiss_cmd = @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "x".ord ]))
+
+      assert_nil dismiss_cmd
       assert_equal :idea_preview, @model.hive_model.mode
-      assert_equal Hive::Tui::Model::NEW_IDEA_BUFFER_MAX_CHARS,
-                   @model.hive_model.idea_preview_text.length
+      assert_equal before.idea_preview_state.token, @model.hive_model.idea_preview_state.token
     end
   end
 
-  def test_idea_preview_roundtrip_open_then_any_key_dismisses
+  def test_grid_q_still_terminates_while_info_panel_q_closes
     with_tmp_dir do |dir|
-      write_idea_md(dir, original_text: "Roundtrip idea")
+      write_idea_md(dir, original_text: "x")
       row = make_task_row(folder: dir)
 
-      _, open_cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      _, term_cmd = @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "q".ord ]))
+      assert_kind_of Bubbletea::QuitCommand, term_cmd
 
-      assert_nil open_cmd
-      assert_equal :idea_preview, @model.hive_model.mode
-      assert_equal "Roundtrip idea", @model.hive_model.idea_preview_text
-
-      _, dismiss_cmd = @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "x".ord ]))
-
-      assert_nil dismiss_cmd
+      @model = Hive::Tui::BubbleModel.new(hive_model: Hive::Tui::Model.initial, dispatch: @dispatch)
+      _, cmd = @model.update(Hive::Tui::Messages::OpenIdeaPreview.new(row: row))
+      drain_idea_preview_cmd(cmd)
+      _, close_cmd = @model.update(Bubbletea::KeyMessage.new(key_type: 0, runes: [ "q".ord ]))
+      assert_nil close_cmd
       assert_equal :grid, @model.hive_model.mode
-      assert_nil @model.hive_model.idea_preview_text
-      assert_nil @model.hive_model.idea_preview_slug
-      assert_empty @messages
     end
   end
 
diff --git a/test/unit/tui/info_panel_content_test.rb b/test/unit/tui/info_panel_content_test.rb
new file mode 100644
index 00000000..a64fbb95
--- /dev/null
+++ b/test/unit/tui/info_panel_content_test.rb
@@ -0,0 +1,326 @@
+require "test_helper"
+require "fileutils"
+require "hive/tui/snapshot"
+require "hive/tui/info_panel_content"
+require "hive/tui/log_tail"
+
+class HiveTuiInfoPanelContentTest < Minitest::Test
+  include HiveTestHelper
+
+  def setup_task_tree(stage:, slug: "info-task-260713-aaaa")
+    root = Dir.mktmpdir("hive-info-panel")
+    @tmp_roots ||= []
+    @tmp_roots << root
+    folder = File.join(root, ".hive-state", "stages", stage, slug)
+    FileUtils.mkdir_p(folder)
+    log_dir = File.join(root, ".hive-state", "logs", slug)
+    FileUtils.mkdir_p(log_dir)
+    [ root, folder, log_dir, slug ]
+  end
+
+  def teardown
+    Array(@tmp_roots).each { |dir| FileUtils.rm_rf(dir) }
+  end
+
+  def write_idea(folder, created_at: "2026-05-20T00:00:00Z", original_text: "Build the thing")
+    body = <<~MD
+      ---
+      slug: info-task
+      created_at: #{created_at}
+      original_text: |
+        #{original_text.lines.map(&:chomp).join("\n  ")}
+      ---
+
+      # idea
+
+      #{original_text}
+    MD
+    path = File.join(folder, "idea.md")
+    File.write(path, body)
+    path
+  end
+
+  def make_row(folder:, stage:, slug: "info-task-260713-aaaa")
+    Hive::Tui::Snapshot::Row.new(
+      project_name: "demo", stage: stage, slug: slug, folder: folder,
+      state_file: File.join(folder, "idea.md"), marker: nil, attrs: {}, mtime: nil,
+      age_seconds: 0, claude_pid: nil, claude_pid_alive: nil,
+      action_key: "ready", action_label: "Ready", suggested_command: nil,
+      next_action: nil, diagnostic: nil
+    )
+  end
+
+  def test_inbox_returns_common_fields_without_stage_extra
+    _root, folder, log_dir, slug = setup_task_tree(stage: "1-inbox")
+    write_idea(folder, original_text: "Inbox idea")
+    log_path = File.join(log_dir, "run-1.log")
+    File.write(log_path, "log line\n")
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "1-inbox", slug: slug))
+
+    assert_equal slug, content.slug
+    assert_equal "1-inbox", content.stage
+    assert content.created_at_available
+    assert_equal "2026-05-20T00:00:00Z", content.created_at
+    assert content.original_text_available
+    assert_includes content.original_text, "Inbox idea"
+    assert_equal File.expand_path(folder), content.task_folder
+    assert content.latest_log_available
+    assert_equal File.expand_path(log_path), content.latest_log_path
+    assert_nil content.stage_extra_kind
+    assert_nil content.stage_extra_label
+    refute content.stage_extra_available
+  end
+
+  def test_brainstorm_returns_brainstorm_md_as_stage_extra
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "2-brainstorm")
+    write_idea(folder)
+    File.write(File.join(folder, "brainstorm.md"), "# Brainstorm\n\nQ1 answer here\n")
+    File.write(File.join(folder, "plan.md"), "should not appear\n")
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "2-brainstorm", slug: slug))
+
+    assert_equal :brainstorm, content.stage_extra_kind
+    assert_equal "brainstorm.md", content.stage_extra_label
+    assert content.stage_extra_available
+    assert_includes content.stage_extra_text, "Q1 answer here"
+    refute_includes content.stage_extra_text, "should not appear"
+  end
+
+  def test_plan_returns_plan_md_as_stage_extra
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "3-plan")
+    write_idea(folder)
+    File.write(File.join(folder, "plan.md"), "## Plan\n\nDo the work\n")
+    File.write(File.join(folder, "brainstorm.md"), "unrelated brainstorm\n")
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "3-plan", slug: slug))
+
+    assert_equal :plan, content.stage_extra_kind
+    assert_equal "plan.md", content.stage_extra_label
+    assert content.stage_extra_available
+    assert_includes content.stage_extra_text, "Do the work"
+    refute_includes content.stage_extra_text, "unrelated brainstorm"
+  end
+
+  def test_bounded_artifact_reads_preserve_valid_utf8
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "3-plan")
+    original_text = "日本語の着想 🙂"
+    plan_text = "## 計画\n\n画面に完全な文字列を表示する\n"
+    write_idea(folder, original_text: original_text)
+    File.write(File.join(folder, "plan.md"), plan_text)
+
+    content = Hive::Tui::InfoPanelContent.load(
+      make_row(folder: folder, stage: "3-plan", slug: slug)
+    )
+
+    assert_includes content.original_text, original_text
+    assert_equal plan_text, content.stage_extra_text
+  end
+
+  def test_execute_selects_newest_common_log_and_newest_execute_log_tail
+    _root, folder, log_dir, slug = setup_task_tree(stage: "4-execute")
+    write_idea(folder)
+    older_common = File.join(log_dir, "review-old.log")
+    newer_common = File.join(log_dir, "other-new.log")
+    older_exec = File.join(log_dir, "execute-20260101T000000Z.log")
+    newer_exec = File.join(log_dir, "execute-20260102T000000Z.log")
+    File.write(older_common, "common old\n")
+    File.write(newer_common, "common new\n")
+    File.write(older_exec, "exec old line\n")
+    File.write(newer_exec, "exec new line 1\nexec new line 2\n")
+    now = Time.now
+    File.utime(now - 400, now - 400, older_common)
+    File.utime(now - 50, now - 50, newer_common)
+    File.utime(now - 300, now - 300, older_exec)
+    File.utime(now - 100, now - 100, newer_exec)
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "4-execute", slug: slug))
+
+    assert content.latest_log_available
+    assert_equal File.expand_path(newer_common), content.latest_log_path
+    assert_equal :execute_log, content.stage_extra_kind
+    assert content.stage_extra_available
+    assert_includes content.stage_extra_text, "exec new line 1"
+    assert_includes content.stage_extra_text, "exec new line 2"
+    refute_includes content.stage_extra_text, "exec old line"
+    refute_includes content.stage_extra_text, "common new"
+  end
+
+  def test_later_stages_return_common_fields_without_stage_extra
+    %w[5-open-pr 9-done].each do |stage|
+      _root, folder, log_dir, slug = setup_task_tree(stage: stage, slug: "later-#{stage.split('-').first}-260713-bbbb")
+      write_idea(folder)
+      File.write(File.join(log_dir, "run.log"), "x\n")
+      File.write(File.join(folder, "plan.md"), "no extra for later stages\n")
+
+      content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: stage, slug: slug))
+
+      assert_equal stage, content.stage
+      assert content.original_text_available
+      assert_nil content.stage_extra_kind, "stage #{stage} must not invent a stage extra"
+      refute content.stage_extra_available
+    end
+  end
+
+  def test_newest_log_selection_skips_vanished_candidate
+    _root, folder, log_dir, slug = setup_task_tree(stage: "1-inbox")
+    write_idea(folder)
+    survivor = File.join(log_dir, "keep.log")
+    File.write(survivor, "still here\n")
+    doomed = File.join(log_dir, "doomed.log")
+
+    original = Dir.method(:[])
+    Dir.singleton_class.define_method(:[]) { |*_args| [ doomed, survivor ] }
+    begin
+      content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "1-inbox", slug: slug))
+    ensure
+      Dir.singleton_class.define_method(:[], original)
+    end
+
+    assert content.latest_log_available
+    assert_equal File.expand_path(survivor), content.latest_log_path
+  end
+
+  def test_missing_optional_files_mark_unavailable_without_raising
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "2-brainstorm")
+    # No idea.md, no brainstorm.md, no logs.
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "2-brainstorm", slug: slug))
+
+    assert_equal slug, content.slug
+    assert_equal File.expand_path(folder), content.task_folder
+    refute content.created_at_available
+    refute content.original_text_available
+    refute content.latest_log_available
+    assert_equal :brainstorm, content.stage_extra_kind
+    refute content.stage_extra_available
+  end
+
+  def test_malformed_idea_frontmatter_partial_content
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "1-inbox")
+    File.write(File.join(folder, "idea.md"), "---\noriginal_text: [broken\n---\n")
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "1-inbox", slug: slug))
+
+    refute content.created_at_available
+    refute content.original_text_available
+    assert_equal slug, content.slug
+  end
+
+  def test_deeply_nested_idea_frontmatter_degrades_without_raising
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "1-inbox")
+    depth = 10_000
+    nested = "#{"[" * depth}0#{"]" * depth}"
+    File.write(File.join(folder, "idea.md"), "---\noriginal_text: #{nested}\n---\n")
+
+    content = Hive::Tui::InfoPanelContent.load(
+      make_row(folder: folder, stage: "1-inbox", slug: slug)
+    )
+
+    refute content.created_at_available
+    refute content.original_text_available
+    assert_equal slug, content.slug
+  end
+
+  def test_markdown_over_byte_cap_is_truncated
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "3-plan")
+    write_idea(folder)
+    oversized = "x" * (Hive::Tui::InfoPanelContent::MARKDOWN_BYTE_CAP + 100)
+    File.write(File.join(folder, "plan.md"), oversized)
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "3-plan", slug: slug))
+
+    assert content.stage_extra_available
+    assert content.stage_extra_truncated
+    assert_operator content.stage_extra_text.bytesize, :<=, Hive::Tui::InfoPanelContent::MARKDOWN_BYTE_CAP
+  end
+
+  def test_idea_over_byte_cap_keeps_bounded_frontmatter_fields
+    _root, folder, _log_dir, slug = setup_task_tree(stage: "1-inbox")
+    original = "beginning\n#{"x" * Hive::Tui::InfoPanelContent::MARKDOWN_BYTE_CAP}\nending"
+    write_idea(folder, original_text: original)
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "1-inbox", slug: slug))
+
+    assert content.created_at_available
+    assert_equal "2026-05-20T00:00:00Z", content.created_at
+    assert content.original_text_available
+    assert content.original_text_truncated
+    assert_includes content.original_text, "beginning"
+    assert_operator content.original_text.bytesize, :<=, Hive::Tui::InfoPanelContent::MARKDOWN_BYTE_CAP
+  end
+
+  def test_idea_over_byte_cap_recovers_quoted_original_text
+    %w[single double].each do |style|
+      slug = "quoted-#{style}-260713-cccc"
+      _root, folder, _log_dir, = setup_task_tree(stage: "1-inbox", slug: slug)
+      quote = style == "single" ? "'" : '"'
+      original = "beginning-#{"x" * Hive::Tui::InfoPanelContent::MARKDOWN_BYTE_CAP}"
+      File.write(
+        File.join(folder, "idea.md"),
+        "---\ncreated_at: 2026-05-20T00:00:00Z\noriginal_text: #{quote}#{original}#{quote}\n---\n"
+      )
+
+      content = Hive::Tui::InfoPanelContent.load(
+        make_row(folder: folder, stage: "1-inbox", slug: slug)
+      )
+
+      assert content.created_at_available, style
+      assert content.original_text_available, style
+      assert content.original_text_truncated, style
+      assert content.original_text.start_with?("beginning-"), style
+    end
+  end
+
+  def test_execute_log_marks_truncation_when_line_ring_limit_is_hit
+    _root, folder, log_dir, slug = setup_task_tree(stage: "4-execute")
+    write_idea(folder)
+    path = File.join(log_dir, "execute-20260103T000000Z.log")
+    File.write(path, "#{(1..51).map { |i| "line-#{i}" }.join("\n")}\n")
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "4-execute", slug: slug))
+
+    assert content.stage_extra_truncated
+    refute_includes content.stage_extra_text, "line-1\n"
+    assert_includes content.stage_extra_text, "line-2"
+    assert_includes content.stage_extra_text, "line-51"
+  end
+
+  def test_long_execute_log_is_bounded
+    _root, folder, log_dir, slug = setup_task_tree(stage: "4-execute")
+    write_idea(folder)
+    path = File.join(log_dir, "execute-20260103T000000Z.log")
+    # More than ring capacity lines and larger than backbuffer.
+    lines = (1..3000).map { |i| "line-#{i}-#{"y" * 40}" }
+    File.write(path, "#{lines.join("\n")}\n")
+
+    content = Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "4-execute", slug: slug))
+
+    assert content.stage_extra_available
+    assert content.stage_extra_truncated
+    assert_includes content.stage_extra_text, "line-3000"
+    refute_includes content.stage_extra_text, "line-1-"
+  end
+
+  def test_load_is_read_only_no_mtime_or_content_mutation
+    _root, folder, log_dir, slug = setup_task_tree(stage: "2-brainstorm")
+    idea = write_idea(folder)
+    brainstorm = File.join(folder, "brainstorm.md")
+    File.write(brainstorm, "keep me\n")
+    log_path = File.join(log_dir, "run.log")
+    File.write(log_path, "log\n")
+    before = {
+      idea: [ File.read(idea), File.mtime(idea) ],
+      brainstorm: [ File.read(brainstorm), File.mtime(brainstorm) ],
+      log: [ File.read(log_path), File.mtime(log_path) ]
+    }
+
+    Hive::Tui::InfoPanelContent.load(make_row(folder: folder, stage: "2-brainstorm", slug: slug))
+
+    assert_equal before[:idea][0], File.read(idea)
+    assert_equal before[:idea][1], File.mtime(idea)
+    assert_equal before[:brainstorm][0], File.read(brainstorm)
+    assert_equal before[:brainstorm][1], File.mtime(brainstorm)
+    assert_equal before[:log][0], File.read(log_path)
+    assert_equal before[:log][1], File.mtime(log_path)
+  end
+end
diff --git a/test/unit/tui/key_map_test.rb b/test/unit/tui/key_map_test.rb
index d58b283e..b8a3a160 100644
--- a/test/unit/tui/key_map_test.rb
+++ b/test/unit/tui/key_map_test.rb
@@ -258,10 +258,18 @@ class TuiKeyMapMessageForTest < Minitest::Test
     assert_equal "i", msg.char
   end
 
-  def test_idea_preview_any_key_returns_back
-    [ "i", "x", :key_enter, :key_escape, "q", :space ].each do |key|
+  def test_idea_preview_close_keys_return_back
+    [ "q", :key_escape, "i" ].each do |key|
       msg = Hive::Tui::KeyMap.message_for(mode: :idea_preview, key: key, row: nil)
-      assert_same Hive::Tui::Messages::BACK, msg, "#{key.inspect} must dismiss idea preview"
+      assert_same Hive::Tui::Messages::BACK, msg, "#{key.inspect} must close info panel"
+    end
+  end
+
+  def test_idea_preview_unmapped_keys_are_noop
+    [ "x", :key_enter, :space, :key_up, :key_down, :key_pgup, :key_pgdn,
+      :key_home, :key_end, "j", "k", "o", "s", "n", "/", "?", "b", "p", "d", "r" ].each do |key|
+      msg = Hive::Tui::KeyMap.message_for(mode: :idea_preview, key: key, row: nil)
+      assert_same Hive::Tui::Messages::NOOP, msg, "#{key.inspect} must be a no-op in info panel"
     end
   end
 
diff --git a/test/unit/tui/log_tail_test.rb b/test/unit/tui/log_tail_test.rb
index c0939a8b..eff94f60 100644
--- a/test/unit/tui/log_tail_test.rb
+++ b/test/unit/tui/log_tail_test.rb
@@ -108,6 +108,27 @@ class TuiLogTailTest < Minitest::Test
     end
   end
 
+  def test_latest_accepts_filename_pattern_without_changing_default
+    with_log_dir do |dir|
+      other = File.join(dir, "review-20260104T000000Z.log")
+      older_exec = File.join(dir, "execute-20260101T000000Z.log")
+      newer_exec = File.join(dir, "execute-20260102T000000Z.log")
+      File.write(other, "review\n")
+      File.write(older_exec, "old exec\n")
+      File.write(newer_exec, "new exec\n")
+      now = Time.now
+      File.utime(now - 10, now - 10, other) # newest overall
+      File.utime(now - 300, now - 300, older_exec)
+      File.utime(now - 100, now - 100, newer_exec)
+
+      assert_equal other, Hive::Tui::LogTail::FileResolver.latest(dir),
+                   "default pattern remains *.log and picks newest by mtime"
+      assert_equal newer_exec,
+                   Hive::Tui::LogTail::FileResolver.latest(dir, pattern: "execute-*.log"),
+                   "pattern must restrict candidates before mtime selection"
+    end
+  end
+
   def test_latest_raises_no_log_files_on_empty_directory
     with_log_dir do |dir|
       err = assert_raises(Hive::NoLogFiles) { Hive::Tui::LogTail::FileResolver.latest(dir) }
@@ -122,6 +143,21 @@ class TuiLogTailTest < Minitest::Test
     end
   end
 
+  def test_latest_ignores_newer_directory_matching_log_pattern
+    with_log_dir do |dir|
+      log_path = File.join(dir, "execute-valid.log")
+      directory_path = File.join(dir, "execute-newer.log")
+      File.write(log_path, "valid log\n")
+      FileUtils.mkdir_p(directory_path)
+      now = Time.now
+      File.utime(now - 60, now - 60, log_path)
+      File.utime(now, now, directory_path)
+
+      assert_equal log_path,
+                   Hive::Tui::LogTail::FileResolver.latest(dir, pattern: "execute-*.log")
+    end
+  end
+
   # The TOCTOU race between Dir[] glob and File.mtime on a rotating
   # log directory used to surface as Errno::ENOENT crashing the TUI.
   # Reproduce the race by overriding Dir.[] to return a path that no
